float4 lightPosition;
float4 lightDiffuse;
float4 lightSpecular;
float exponent;
sampler Tex0: register(s0);

float4 main(
	float4 pos: TEXCOORD0,
	float2 uv: TEXCOORD1,
	float3 normal: TEXCOORD2,
	//float4 lightPos: TEXCOORD3,
	float3 eyePos: TEXCOORD4
): COLOR
{
	float3 N = normalize(normal);

	float3 EyeDir = normalize(eyePos - pos.xyz);
	float3 LightDir = normalize(lightPosition.xyz - (pos * lightPosition.w));
	float3 HalfAngle = normalize(LightDir + EyeDir);

	float NdotL = dot(LightDir, N);
	float NdotH = dot(HalfAngle, N);
	float4 Lit = lit(NdotL, NdotH, exponent);

	float3 texColor = tex2D(Tex0, uv).xyz;
//	texColor = (texColor - 0.5) * 2;

	return float4(texColor, 1) + lightDiffuse * Lit.y + lightSpecular * Lit.z;
}
